"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _eventEmitter = require("../utils/eventEmitter");

var _eventEmitter2 = _interopRequireDefault(_eventEmitter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright (c) 2015-present, CWB SAS
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var SocketService = function (_EventEmitter) {
  _inherits(SocketService, _EventEmitter);

  function SocketService(url) {
    _classCallCheck(this, SocketService);

    var _this = _possibleConstructorReturn(this, (SocketService.__proto__ || Object.getPrototypeOf(SocketService)).call(this));

    _this.url = url;
    _this.socket = null;
    _this.running = false;
    return _this;
  }

  _createClass(SocketService, [{
    key: "start",
    value: function start() {
      var _this2 = this;

      if (this.running || this.socket) {
        return;
      }
      this.running = true;
      /* eslint-disable no-undef */
      this.socket = new WebSocket(this.url);
      /* eslint-enable no-undef */
      this.socket.addEventListener("open", function () {
        _this2.emit("open");
      });
      this.socket.addEventListener("message", function (e) {
        var data = null;
        var d = e.data.trim();
        var event = null;
        if (d.charAt(0) === "{" || d.charAt(0) === "[") {
          var o = JSON.parse(d);
          event = o.event;

          data = o.result;
        } else {
          event = d;
        }
        if (_this2.socket && event === "ping") {
          _this2.socket.send("pong");
        } else if (event) {
          _this2.emit(event, data);
        }
      });

      this.socket.addEventListener("error", function (error) {
        _this2.emit("error", error);
      });

      this.socket.addEventListener("close", function () {
        if (_this2.running) {
          _this2.emit("close");
        }
        _this2.socket = null;
        _this2.running = false;
      });
      var that = this;
      this.interval = setInterval(function () {
        if (!that.socket && !that.running) {
          that.start();
        }
      }, 1000);
    }
  }, {
    key: "send",
    value: function send(data) {
      if (this.socket) {
        this.socket.send(data);
      }
    }
  }, {
    key: "close",
    value: function close() {
      if (this.interval) {
        clearInterval(this.interval);
        this.interval = null;
      }
      if (this.socket) {
        this.socket.close();
        this.socket = null;
      }
    }
  }]);

  return SocketService;
}(_eventEmitter2.default);

exports.default = SocketService;
//# sourceMappingURL=socketService.js.map