"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Copyright (c) 2015-present, CWB SAS
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

// Inspiration : https://gist.github.com/mudge/5830382
var EventEmitter = function () {
  function EventEmitter() {
    _classCallCheck(this, EventEmitter);

    this.events = {};
  }

  _createClass(EventEmitter, [{
    key: "on",
    value: function on(event, listener) {
      if (!this.events[event] || !Array.isArray(this.events[event])) {
        this.events[event] = [];
      }
      this.events[event].push(listener);
    }
  }, {
    key: "removeListener",
    value: function removeListener(event, listener) {
      var events = this.events[event];
      if (events && Array.isArray(events)) {
        var idx = events.indexOf(listener);
        if (idx > -1) {
          events.splice(idx, 1);
        }
      }
    }
  }, {
    key: "emit",
    value: function emit(event) {
      var _this = this;

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var events = this.events[event];
      if (events && Array.isArray(events)) {
        this.listeners = this.events[event].slice();
        this.listeners.forEach(function (l) {
          l.apply(_this, args);
        });
      }
    }
  }, {
    key: "once",
    value: function once(event, listener) {
      for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
        args[_key2 - 2] = arguments[_key2];
      }

      var _this2 = this;

      var that = this;
      this.on(event, function () {
        that.removeListener(event, _this2);
        listener.apply(that, args);
      });
    }
  }]);

  return EventEmitter;
}();

exports.default = EventEmitter;
//# sourceMappingURL=eventEmitter.js.map